
#property copyright "gince"


#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Blue


extern int Per=24;
extern double maxCh=800;

double ExtMapBuffer1[];
double ExtMapBuffer2[];

//-----------------------------------------------------------
int init()
  {

   SetIndexStyle(0,DRAW_LINE,EMPTY,3);
   //SetIndexArrow(0,159);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexEmptyValue(0,0.0);
   
   SetIndexStyle(1,DRAW_LINE,EMPTY,3);
   //SetIndexArrow(1,159);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexEmptyValue(1,0.0);   

   return(0);
  }
//-------------------------------------------------------------
int deinit()
  {

   return(0);
  }
//---------------------------------------------------------------
int start()
   {
     
      int limit;
      int counted_bars=IndicatorCounted(); 
      
      //----
   
      if(counted_bars>0) counted_bars--;
         {
            limit=Bars-counted_bars;
         }
      //i=Bars-counted_bars-1;
   
      for(int i=0; i<limit; i++)
          {
                  double h     =  High[iHighest(NULL,0,MODE_HIGH,Per,i)];    
                  double l     =  Low[iLowest(NULL,0,MODE_LOW,Per,i)];                   
                  datetime time     =  TimeCurrent();
                  string nUp      =  "Up_";
                  string nDown    =  "Down_";
                  int Ch    =  (h-l)*1000;
                  datetime tim   =  iTime(NULL,0,Per);
                  
                  if(Ch <  maxCh)
                     {
                        ObjectCreate("nUp ", OBJ_TREND, 0, tim, h, time, h);
                        ObjectCreate("nDown", OBJ_TREND, 0, tim, l, time, l);
                                                
                        ExtMapBuffer1[i]= h; 
                        ExtMapBuffer2[i]= l;
                     }
                           
                  //Comment( "Chenell_0   ",Ch+ "\n" +                           
                   //        "h          ",h+"\n"   +                          
                   //        "l          ",l);
            }
       //double h_ch = h;
       //double l_ch = l;
       //double H = iHigh(NULL,0,0);
       //double L = iLow(NULL,0,0);
       Comment( "Chenell_0   ",Ch+ "\n" +                           
                           "h          ",h+"\n"   +                          
                           "l          ",l
                           //+"\n" +                           
                          // "H          ",H+"\n"   +                          
                          // "L          ",L
                          );
       //if(h<H)  DrawFibo(time,l,h,Lavender);
       //if(l>L)  DrawFibo(time,h,l,Lavender);
         
   return(0);
  }
 //------------------------------------------------------
void DrawFibo(datetime time, double price0, double price100,color col)
{
   string name = "1_ch" + time;
   ObjectCreate(name, OBJ_FIBO, 0, time, price100, time, price0);
   ObjectSet(name, OBJPROP_COLOR, Yellow);
   ObjectSet(name, OBJPROP_STYLE, STYLE_SOLID);
   ObjectSet(name, OBJPROP_FIBOLEVELS, 6);
   ObjectSet(name, OBJPROP_FIRSTLEVEL + 0, 0);
   ObjectSet(name, OBJPROP_FIRSTLEVEL + 1,0.236);
   ObjectSet(name, OBJPROP_FIRSTLEVEL + 2, 1);
   ObjectSet(name, OBJPROP_FIRSTLEVEL + 3, 1.618);
   ObjectSet(name, OBJPROP_FIRSTLEVEL + 4, 2.618);
   ObjectSet(name, OBJPROP_FIRSTLEVEL + 5, 4.236);
   ObjectSet(name, OBJPROP_LEVELCOLOR, col);
   
   ObjectSetFiboDescription(name, 0, "0 %");
   ObjectSetFiboDescription(name, 1, "23.6 %");
   ObjectSetFiboDescription(name, 2, "100 %");
   ObjectSetFiboDescription(name, 3, "161.8 %");
   ObjectSetFiboDescription(name, 4, "261.8 %");
   ObjectSetFiboDescription(name, 5, "423.6 %");
   //ObjectSet(name, OBJPROP_RAY, false);
}